package com.liang.sca.goods.controller;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.IdUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.liang.sca.goods.mapper.GoodsInfoMapper;
import com.liang.sca.goods.model.GoodsInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigInteger;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

@RestController
@RequestMapping("/goods")
public class GoodsController {

    @Value("${spring.application.name}:${server.port}")
    String info;

    @Autowired
    private GoodsInfoMapper goodsInfoMapper;

    @RequestMapping("/demo")
    public String demo(){
        return "this is : " + info;
    }

    @RequestMapping("/snowflake")
    public String snowflake(){
        Snowflake snowflake = IdUtil.getSnowflake();
        return snowflake.nextIdStr();
    }

    @RequestMapping("/infos")
    public List<Map<String, Object>> queryInfos(){
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("c_goods_name", "星见雅");
        List<Map<String,Object>> results = goodsInfoMapper.selectMaps(queryWrapper);
        return results;
    }

    @RequestMapping("/buy/{goodsId}/{counts}")
    public void buyGodds(@PathVariable BigInteger goodsId, @PathVariable int counts){
        GoodsInfo goodsInfo = goodsInfoMapper.selectById(goodsId);
        int nowStore = goodsInfo.getGoodsStore() - counts;
        goodsInfo.setGoodsStore(nowStore);
        goodsInfoMapper.updateById(goodsInfo);
    }


}
