package com.liang.sca.goods.controller;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.liang.sca.goods.mapper.ProductSkuMapper;
import com.liang.sca.goods.mapper.ProductSpuMapper;
import com.liang.sca.goods.model.ProductSku;
import com.liang.sca.goods.model.ProductSpu;
import com.liang.sca.goods.model.vo.ProductVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/product")
public class ProductController {

    @Autowired
    private ProductSpuMapper spuMapper;

    @Autowired
    private ProductSkuMapper skuMapper;

    @GetMapping("/infos")
    public List<ProductVo> queryInfos(){
        QueryWrapper queryWrapper = new QueryWrapper();
        List<ProductSpu> list = spuMapper.selectList(queryWrapper);
        List<ProductVo> productVos = BeanUtil.copyToList(list, ProductVo.class);
        for (ProductVo vo : productVos) {
            QueryWrapper skuQueryWrapper = new QueryWrapper();
            skuQueryWrapper.eq("spu_id", vo.getSpuId());
            List<ProductSku> skus = skuMapper.selectList(skuQueryWrapper);
            vo.setSkus(skus);
        }
        return productVos;
    }

    @GetMapping("/infos/{spuId}")
    public ProductVo queryInfos(@PathVariable int spuId){
        ProductSpu productSpu = spuMapper.selectById(spuId);
        ProductVo productVo = new ProductVo();
        BeanUtils.copyProperties(productSpu, productVo);
        QueryWrapper<ProductSku> skuQueryWrapper = new QueryWrapper<>();
        skuQueryWrapper.eq("spu_id", spuId);
        List<ProductSku> productSkus = skuMapper.selectList(skuQueryWrapper);
        productVo.setSkus(productSkus);
        return productVo;
    }

    @RequestMapping("/buy/{skuId}/{counts}")
    public void buyGodds(@PathVariable BigInteger skuId, @PathVariable int counts){
        ProductSku productSku = skuMapper.selectById(skuId);
        int skuStore = productSku.getSkuStore() - counts;
        productSku.setSkuStore(skuStore);
        skuMapper.updateById(productSku);
        ProductSpu productSpu = spuMapper.selectById(productSku.getSpuId());
        int spuStore = productSpu.getSpuStore() - counts;
        productSpu.setSpuStore(spuStore);
        spuMapper.updateById(productSpu);
    }
}
