package com.liang.sca.goods.controller;

import com.liang.sca.goods.mapper.GoodsInfoMapper;
import com.liang.sca.goods.mapper.ProductSkuMapper;
import com.liang.sca.goods.model.GoodsInfo;
import com.liang.sca.goods.model.ProductSku;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/seckill")
public class SecKillController {

    @Autowired
    private RedisTemplate<String, Object> redisTemplate;

    @Autowired
    private ProductSkuMapper skuMapper;

    /**
     * 创建秒杀活动
     * @return 操作结果信息
     */
    @RequestMapping("/create/{skuId}")
    public String createSecKillActivity(@PathVariable int skuId) {
        // 根据 id 查询 tb_goods_info 表
        ProductSku productSku = skuMapper.selectById(skuId);
        if (productSku == null) {
            return "商品信息不存在";
        }
        // 以 goodsId 为 key，将库存放入 redis 中
        String key = "seckill:product:" + skuId;
        redisTemplate.opsForValue().set(key, productSku.getSkuStore());
        return "秒杀活动创建成功";
    }
}
