package com.liang.sca.order.controller;

import cn.hutool.core.collection.CollectionUtil;
import com.liang.sca.order.mapper.OrderInfoMapper;
import com.liang.sca.order.model.OrderInfo;
import com.liang.sca.order.service.GoodsInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigInteger;
import java.util.Collections;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/order")
public class OrderInfoController {

    @Autowired
    private OrderInfoMapper orderInfoMapper;

    @Autowired
    private GoodsInfoService goodsInfoService;

    @RequestMapping("/buy/{counts}")
    public String buyGoods(@PathVariable int counts){
        List<Map<String, Object>> maps = goodsInfoService.queryGoodsInfo();
        if(CollectionUtil.isNotEmpty(maps)){
            Map<String, Object> goodsInfo = maps.get(0);
            BigInteger goodsId = BigInteger.valueOf((long)goodsInfo.get("goodsId"));
            String goodsName = goodsInfo.get("goodsName").toString();
            OrderInfo orderInfo = new OrderInfo();
            goodsInfoService.buyGoods(goodsId, counts);
            return "商品:"+goodsName+",下单数量:"+counts+"件下单成功";
        } else {
            return "没找到商品";
        }
    }
}
